﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Newtonsoft.Json;


namespace CustomConverters
{
    public class Unit
    {
        public Guid OID { get; set; }
        public string Name { get; set; }

        //[JsonIgnore]
        public List<Unit> Units { get; set; }


        public Unit( string name = "Unnamed Unit" )
            : this( name, Guid.NewGuid() )
        {
        }

        public Unit( string name, Guid oid )
        {
            this.OID = oid;
            this.Name = $"{name} - {oid}";
            this.Units = new List<Unit>();
        }

        public static Unit TestChild()
        {
            return new Unit( "Test Child" );
        }

        public static Unit TestParent()
        {
            Unit parent = new Unit( "Test Parent" );
            parent.Units.Add( new Unit( "Test Child 1" ) );
            parent.Units.Add( new Unit( "Test Child 2" ) );
            parent.Units.Add( new Unit( "Test Child 3" ) );
            return parent;
        }
    }
}
