﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CustomConverters
{
    class UnitDecorator
    {
        public List<Guid> UnitIDs { get; set; }

        public string Id
        {
            get
            {
                return this.UnitID.ToString();
            }
            set
            {
                this.UnitID = Guid.Parse( value );
            }
        }

        public string Name { get; set; }
        public Guid UnitID { get; set; }

        public UnitDecorator()
        {
            this.UnitIDs = new List<Guid>();
        }

        public UnitDecorator( Unit org )
        {
            this.Name = org.Name;
            this.UnitID = org.OID;
            this.UnitIDs = new List<Guid>( org.Units.Select( unit => unit.OID ) );
        }

        public Unit AsUnit()
        {
            Unit newUnit = new Unit( this.Name, this.UnitID );
            return newUnit;
        }
    }
}
